package com.qs.mp.task;

import cn.hutool.core.codec.Base62;
import cn.hutool.core.date.LocalDateTimeUtil;
import cn.hutool.core.util.HashUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.NumberUtil;
import cn.hutool.crypto.SecureUtil;
import cn.hutool.crypto.symmetric.DES;
import cn.hutool.crypto.symmetric.SymmetricAlgorithm;
import cn.hutool.crypto.symmetric.SymmetricCrypto;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.eptok.yspay.opensdkjava.fund.MercFundApi;
import com.eptok.yspay.opensdkjava.pojo.vo.OnlineReqDataVo;
import com.eptok.yspay.opensdkjava.util.Base64Utils;
import com.eptok.yspay.opensdkjava.util.DateUtil;
import com.eptok.yspay.opensdkjava.util.SrcDesUtil;
import com.eptok.yspay.opensdkjava.util.YsOnlineSignUtils;
import com.eptok.yspay.opensdkjava.util.YsfSignUtil;
import com.qs.mp.admin.domain.Coupon;
import com.qs.mp.admin.domain.CouponTicket;
import com.qs.mp.admin.domain.GoodsCard;
import com.qs.mp.admin.domain.Marketing;
import com.qs.mp.admin.service.ICouponChannelService;
import com.qs.mp.admin.service.ICouponService;
import com.qs.mp.admin.service.ICouponTicketService;
import com.qs.mp.admin.service.IGoodsCardService;
import com.qs.mp.common.core.redis.DistributedLocker;
import com.qs.mp.common.core.redis.RedisCache;
import com.qs.mp.common.enums.UserTypeEnum;
import com.qs.mp.common.utils.AESUtil;
import com.qs.mp.common.utils.DateUtils;
import com.qs.mp.common.utils.RSAUtil;
import com.qs.mp.common.utils.WebhookService;
import com.qs.mp.common.utils.html.EscapeUtil;
import com.qs.mp.common.utils.http.OkHttpUtil;
import com.qs.mp.common.utils.uuid.IdUtils;
import com.qs.mp.common.utils.uuid.UUID;
import com.qs.mp.framework.service.IWxSubscribeMessage;
import com.qs.mp.pay.service.IWalletService;
import com.qs.mp.quartz.task.DayStatTask;
import com.qs.mp.quartz.task.MarketingTask;
import com.qs.mp.quartz.task.TicketOrderTask;
import com.qs.mp.system.service.id.BizIdGenerator;
import com.qs.mp.user.domain.MarketingUserCode;
import com.qs.mp.user.service.IMarketingUserCodeService;
import com.qs.mp.utils.SecurityUtils;
import java.util.concurrent.TimeUnit;
import org.apache.commons.lang3.RandomStringUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.client.methods.HttpRequestBase;
import org.junit.jupiter.api.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.IOException;
import java.time.LocalDateTime;
import java.util.*;

/**
 * @author Cup
 * @date 2022/4/26
 */
@SpringBootTest
public class MyTest {
    protected final Logger logger = LoggerFactory.getLogger(this.getClass());


    @Autowired
    private IWalletService walletService;

    @Autowired
    private MarketingTask marketingTask;

    @Autowired
    private RedisCache redisCache;

    @Autowired
    private BizIdGenerator bizIdGenerator;

    @Autowired
    private IWxSubscribeMessage wxSubscribeMessage;


    @Autowired
    private IMarketingUserCodeService marketingUserCodeService;


    @Autowired
    private DayStatTask dayStatTask;

    @Autowired
    private ICouponService couponService;

    @Autowired
    private ICouponChannelService couponChannelService;

    @Autowired
    private ICouponTicketService couponTicketService;


    @Autowired
    private IGoodsCardService goodsCardService;

    @Autowired
    private DistributedLocker distributedLocker;

    @Autowired
    private TicketOrderTask ticketOrderTask;

    @Value("${ys-pay.serverUrl}")
    private String serverUrl;

    @Value("${ys-pay.partner-id}")
    private String partnerId;

    @Value("${ys-pay.private-key-pass}")
    private String privateKeyPass;


    @Test
    void test18() {
        walletService.h5Pay(null,"023902109123",100,"测试测试测试");
    }

    @Test
    void test17() {
        OnlineReqDataVo req = new OnlineReqDataVo();
        //请求路径,建议配置在项目的配置文件里面
        String reqUrl = "https://commonapi.ysepay.com/gateway.do";
        //私钥证书存放路径,建议配置在项目的配置文件里面
        String privateKeyFilePath = "/Users/cup/Downloads/ysPayPre.pfx";
        //ys公钥证书存放地址 建议配置在项目的配置文件里面
        String publicKeyFilePath = "/Users/cup/Downloads/ysPayPub.cer";
        //私钥证书密钥,建议配置在项目的配置文件里面
        String privateKeyPassworde = "FAl9S8TmGB80";

        //商户在银盛支付平台开设的用户号[商户号],接入时需要替换成自己的
        req.setPartnerId(partnerId);
        req.setReqUrl(reqUrl);
        req.setPrivateKeyFilePath(privateKeyFilePath);
        req.setPrivateKeyPassword(privateKeyPassworde);
        req.setYsPublicKeyFilePath(publicKeyFilePath);
        //商户余额查询业务参数
        Map<String, Object> bizContent = new HashMap<>();
        bizContent.put("merchant_usercode", partnerId);//商户号
        req.setParamData(bizContent);
        String result = null;
        try{
            logger.info("账户余额查询调用sdk接口addScanMerc请求入参为:"+ JSONObject.toJSONString(req));
            //根据返回结果处理自己的业务逻辑,result内容详见接口文档
            result = MercFundApi.getFundAccount(req);
        }catch (Exception e){
            logger.info("账户余额查询失败:"+ e.getMessage());
        }
    }

    @Test
    void test16() throws Exception {

        Map<String,String> mapData = new HashMap<>();
        mapData.put("partner_id", partnerId);
        mapData.put("method","ysepay.authenticate.three.key.element.precise");
        mapData.put("timestamp", DateUtil.getDateNow());
        mapData.put("sign_type", "RSA");
        mapData.put("charset", "utf-8");
        mapData.put("version", "3.0");
        mapData.put("notify_url","http://127.0.0.1");
//        mapData.put("out_trade_no", "202003276843192280647119");

        JSONObject json = new JSONObject();
        json.put("out_trade_no", DateUtil.getDateNowYmd() + DateUtil.getRandom(6));
        json.put("shopdate","20200328");
        json.put("bank_account_name", "张三");
        json.put("bank_account_no", "6212260488888888888");
        json.put("id_card", SrcDesUtil.encryptData("ecolosha","41022319940916602X"));
        mapData.put("biz_content",json.toString());
        //参数签名
        try{
            String mp1688 = YsfSignUtil.sign(mapData, "/Users/cup/Downloads/ysPayPre.pfx",privateKeyPass);
            System.out.println("mp1688 = " + mp1688);
            mapData.put("sign", mp1688);

        } catch (Exception e){
            System.err.println("签名异常" + e);
        }

        String post = OkHttpUtil.post("https://openapi.ysepay.com/gateway.do", mapData);
        System.out.println("返回" + post);

    }

    @Test
    void test15() {
        ticketOrderTask.cancel();

    }

    @Test
    void test14() {
        distributedLocker.tryLock("goods_card_lock_key_466",0,-1, TimeUnit.SECONDS);
    }

    @Test
    void test13() {
        List<GoodsCard> goodsCardList = goodsCardService.list(new QueryWrapper<GoodsCard>()
            .eq("is_use", 1));
        goodsCardList.forEach(System.out::println);
    }

    @Test
    void test12() {
        Coupon coupon = couponService.getById(56);
        String description = coupon.getDescription();
        String s = description.replaceAll("\\n", "<br>");
        System.out.println("coupon.getDescription() = " + s);
    }

    @Test
    void test11() {
        boolean remove = couponTicketService.remove(
            new LambdaQueryWrapper<CouponTicket>().eq(CouponTicket::getCouponId, 11));
        System.out.println("remove = " + remove);
    }


    @Test
    void test10(){
        for (int i = 0; i < 1; i++) {
            couponService.distributeByMarketing(188L,"56");
        }

    }

    @Test
    void test9() {
        Marketing marketing = new Marketing();
        marketing.setId(44L);
        marketing.setTitle("测试测试");
        wxSubscribeMessage.sendMarketingLottery(187L, marketing);

    }

    @Test
    void test8(){
        dayStatTask.stat("20220713");
    }


    @Test
    void test7() {
        String hellow = AESUtil.encrypt("hellow");
        System.out.println("hellow = " + hellow);
        String decrypt = AESUtil.decrypt("hahaha");
        System.out.println("decrypt = " + decrypt);
    }


    @Test
    void test6(){
//        List<MarketingUserCode> userCodeList = marketingUserCodeService.list(new LambdaQueryWrapper<MarketingUserCode>()
//                .select(MarketingUserCode::getUserId)
//                .eq(MarketingUserCode::getMarketingId, 102)
////                .eq(MarketingUserCode::getUserType, UserTypeEnum.ORDINARY.getValue())
//                .groupBy(MarketingUserCode::getUserId));
        List<MarketingUserCode> userCodeList = marketingUserCodeService.list(new LambdaQueryWrapper<MarketingUserCode>()
                .select(MarketingUserCode::getUserId)
                .eq(MarketingUserCode::getUserType, UserTypeEnum.ORDINARY.getValue())
                .groupBy(MarketingUserCode::getUserId));
        userCodeList.forEach(System.out::println);
    }

    @Test
    void test5() {
        Set<String> testSet =new HashSet<>();
        testSet.add("test1");
        testSet.add("test2");
        testSet.add("test3");
        testSet.add("test4");
        redisCache.setCacheSet("testSet",testSet);
        List<Object> list = new ArrayList<>();
        list.add("test1");
        list.add("test3");
        list.add("test5");
        list.add("test6");
        list.add("test7");
        redisCache.removeSetValueByKey("testSet",list);


    }

    @Test
    void test4() {
        Marketing marketing = new Marketing();
        marketing.setId(45L);
        marketing.setTitle("测试订阅通");
        wxSubscribeMessage.sendMarketingLottery(188L, marketing);
        wxSubscribeMessage.sendMarketingLottery(79L, marketing);

//        wxSubscribeMessage.sendMarketingStart(188L, marketing);
//        wxSubscribeMessage.sendMarketingStart(79L, marketing);

//        wxSubscribeMessage.sendMarketingHelp(188L, marketing);
//        wxSubscribeMessage.sendMarketingHelp(79L, marketing);
    }
    
    @Test
    void test2() throws IOException {
        marketingTask.lottery();

    }

    @Test
    void test3(){
        for (int i = 0; i < 20; i++) {
            System.out.println("bizIdGenerator = " + bizIdGenerator.newId());
        }

    }



    @Test
    void test1(){
        walletService.refund("968527112497659906",10,"测试");
    }

}
